#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "nabort.h"

void nabort(const char *fmt,...)
{
  va_list ap;
  va_start(ap, fmt);
  vfprintf(stderr, fmt, ap);
  va_end(ap);
  fprintf(stderr,"\n");
  exit(1);
}

void * ntMalloc(int size)
{
  void *block = malloc(size);
  if(block == NULL) nabort("Memory allocation failed. size=%d byte\n",size);
  return block;
}

char *ntStringNew(const char *str)
{
  char *new_str = ntMalloc(strlen(str)+1);
  strcpy(new_str,str);
  return new_str;
}

void ntFree(void *block)
{
  free(block);
}
